;
;	Videlejtsz program VT-DOS-ra
;
;
;


	.org 0100h			; a VT-DOS programok betltsi cme


pmain:	ld	sp,03FF0h		; sajt veremterlet kialaktsa U0 tetejn
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; memrialapozs belltsa
;
	ld	a,(00052h)		; A reg.= diszk RAM belapozsi rtke
	ld	c,a
	rra				; 7. s 6. bit jobbra lptetse 2-vel
	rra
	and	030h			; jobbra lptetett bitek megtartsa
	xor	0EFh			; bziscm fels bjtjnak hozzadsa
	ld	h,a			; HL Port3 msolatra mutat a diszk RAM-ban
	ld	l,0FEh
	ld	a,c			; A reg.= diszk RAM belapozsi rtke
	di
	out	(002h),a		; memrialapozs belltsa
	ld	a,(hl)
	ld	(Port3),a		; Port3 rtke a sajt vltozba
	dec	hl
	ld	a,(hl)
	ld	(Port5),a		; Port5 rtke a sajt vltozba
	ld	a,090h			; U0,U1,VID,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; felhasznli memrialapozs belltsa
	ei
	call	ed_dosoff		; VT-DOS kurzor kikapcsolsa
	ld	hl,0BE80h		; konzol I/O vltozinak lementse a vidememribl
	ld	de,UPMIOsave
	ld	bc,00030h
	ldir
;
	ld	a,(0052h)		; FISH hvs memrialapozsi rtke A reg.-be
	ld	(FISH_page),a		; eredeti rtk elmentse
	and	0DFh			; PAGE2 belltsa a vide memrira
	ld	(0052h),a		; mdostott lapozsi rtk visszarsa		
	ld	hl,0005Dh		; HL az els paramterben megadott 8+3 -as fjlnvre mutat
	call	vidplay			; video lejtszsa
	ld	a,(FISH_page)
	ld	(0052h),a		; FISH hvs memrialapozsi rtknek helyrelltsa
	call	settime			; rendszerid utnlltsa
	ld	c,000h			; 2-szn md belltsa
	call	vidmod
	ld	hl,UPMIOsave		; konzol I/O vltozinak helyrelltsa
	ld	de,0BE80h
	ld	bc,00030h
	ldir
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; memrialapozs belltsa
	call	ed_doson		; VT-DOS kurzor bekapcsolsa
;
exit:	jp	0000h			; vissza a VT-DOS-ba



;
;
;	Rendszerid mdostsa (ha a dtum tfordulna, akkor nem mdostja az idt sem)
;	in:  -
;	out: -
;
settime:call	vidtime			; eltelt id kiszmtsa
	push	hl
	push	de
	ld	c,02Ch			; C= funkcikd: id beolvassa
	call	0005h			; VT-DOS hvsa
	ex	(sp),hl			; H= eltelt msodpercek
	ld	a,d
	add	a,h
	cp	60
	jr	c,stime0		; ugrs, ha nincs tvitel a msodpercrl
	sub	60
stime0:	ccf
	ld	d,a			; D= mdostott msodpercek
	pop	bc			; B= rk  C= percek
	pop	hl			; H= eltelt rk  L= eltelt percek
	ld	a,c
	adc	a,l			; percek nvelse
	cp	60
	jr	c,stime1		; ugrs, ha nincs tvitel a percrl
	sub	60
stime1:	ccf
	ld	l,a			; L= mdostott percek
	ld	a,b
	adc	a,h			; rk nvelse (dtumot nem nveli!)
	ld	h,a			; H= mdostott rk
	cp	24			; rk tfordulsnak ellenrzse
	ld	c,02Dh			; C= funkcikd: id belltsa
	call	c,0005h			; VT-DOS hvsa, ha az rk nem fordultak t
	ret


;
;	VT-DOS konzol kurzor kikapcsolsa
;	in:  -
;	out: -
;
ed_dosoff:
	ld	de,curoff
	jr	ed_str


;
;	VT-DOS konzol kurzor bekapcsolsa
;	in:  -
;	out: -
;
ed_doson:
	ld	de,curon
ed_str:	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ret


;
;	ESC szekvencik a kurzor be/ki kapcsolshoz
;

curoff:	.db	00Ch			; kperny trlse
	.db	01Bh,"x5"		; kurzor kikapcsolsa
	.db	'$'			; stringet zr '$' karakter

curon:	.db	00Ch			; kperny trlse
	.db	01Bh,"y5"		; kurzor bekapcsolsa
	.db	'$'			; stringet zr '$' karakter


;
;	VT-DOS konzol kurzor pozcionlsa
;	in:   B - oszlop (soron belli pozci)
;	      C - sor (1..24)
;	out: -
;
ed_doscpos:
	push	bc
	ld	e,01Bh			; ESC szekvencia kezdete
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,'Y'			; kurzor pozcinlsa
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	bc
	push	bc
	ld	a,c			; sor
	add	a,01Fh			; 020h hozzadsa, -1 mert a konzol 0-tl szmoz
	ld	e,a
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	bc
	ld	a,b			; oszlop
	add	a,01Fh			; 020h hozzadsa, -1 mert a konzol 0-tl szmoz
	ld	e,a
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ret


;
;
;	Szveg msolsa adott hosszon, a specilis karakter tlpsvel
;	in:   B - hossz
;	      C - specilis karakter
;	     DE - cl
;	     HL - forrs
;	out:  B - nem msolt karakterek szma
;	      C - megrzdik
;	     DE - utols msolt karakter utn mutat
;	     HL - az adott hossz utni karakterre mutat
;
fscpy:	ld	a,(hl)			; msoland karakter A reg.-be
	cp	c
	jr	z,fscp0			; ugrs, ha specilis karakter
	ld	(de),a
	inc	de
	inc	hl
	djnz	fscpy			; ismtls a megadott hosszig
	ret
;
fscp0:	ld	a,l			; forrscm nvelse, ha vannak nem msolt karakterek
	add	a,b
	ld	l,a
	ret	nc
	inc	h
	ret


;
;	Kls modulokbl beillesztend programrszek
;

;
	#include "videolib.asm"
;
	#include "util.asm"
;

;
;	Vltoz terlet kezdete
;
;
dstart		.equ	$
FCB_0		.equ	dstart +0	; FCB0 (48 bjt)
FCB_1		.equ	dstart +48	; FCB1 (48 bjt)
vidtimeL	.equ	dstart +96	; lejtszsi id szmllja, als sz (2 bjt)
vidtimeH	.equ	dstart +98	; lejtszsi id szmllja, fels sz (2 bjt)
framelen	.equ	dstart +100	; egy frame hossza bjtokban (2 bjt)
curpos		.equ	dstart +102	; kurzorpozci a frame elejhez kpest (2 bjt)
sndaddr		.equ	dstart +104	; hangmintk kezdete az 1. kppuffer elejhez kpest (2 bjt)
sndend		.equ	dstart +106	; hangmintk vge az 1. kppuffer elejhez kpest (2 bjt)
playadr		.equ	dstart +108	; aktulisan lejtszott mintabjt cme (2 bjt)
sample		.equ	dstart +110	; aktulisan lejtszott mintabjt s bjton belli szmll (2 bjt)
nsamples	.equ	dstart +112	; egy frame-hez tartoz hangmintk szma (2 bjt)
pitch		.equ	dstart +114	; hang-mintavteli frekvencia pitch rtke (2 bjt)
israddr		.equ	dstart +116	; aktulis megszaktskiszolgl rutin cme (2 bjt)
osint		.equ	dstart +118	; eredeti megszak. rutin visszalltand kdrszlete (3 bjt)
ivector		.equ	dstart +121	; I regiszter mentett rtke megszakts-tlltskor (1 bjt)
imode		.equ	dstart +122	; eredeti megszaktsi md: 0-> IM2  !0-> IM1 (1 bjt)
Port3		.equ	dstart +123	; Port3 indulskori rtke (1 bjt)
Port5		.equ	dstart +124	; Port5 indulskori rtke (1 bjt)
FISH_page	.equ	dstart +125	; FISH hvs eredeti lapozsi rtke (1 bjt)
bcdMSB		.equ	dstart +126	; BCD alak szm trolshoz a BIN->ASCII konverzinl (5 bjt)
bcdLSB		.equ	dstart +130
UPMIOsave	.equ	dstart +131	; konzol I/O lementett vltozi a vidememria vgrl (48 bjt)
puffer		.equ	dstart +179	; szabadon hasznlhat terlet


.end

